﻿
class EmployeeInfoMain
{
    static void Main()
    {
        const int NUM = 2;
        List<EmployeeInfoSTL> empl = new List<EmployeeInfoSTL>();

        EmployeeInfoSTL empl1 = new EmployeeInfoSTL("Sarah Smith", "Chief Financial Officer", 212000.00);
        EmployeeInfoSTL empl2 = new EmployeeInfoSTL("Michal Dabrowski", "Software Developer", 90000.00);
        EmployeeInfoSTL empl3 = new EmployeeInfoSTL("Jessica Lee", "Design Engineer", 92000.00);

        empl.Add(empl1);
        empl.Add(empl2);
        empl.Add(empl3);

        for (int i = 0; i < empl.Count; ++i)
        {
            EmployeeInfoSTL.Err_Status ret = empl[i].PrintInfo();
            if (ret == EmployeeInfoSTL.Err_Status.Err_Failure)
            {
                Console.WriteLine($"Failed to get information for {empl[i].GetName()}\n");
            }
        }
        Console.WriteLine();

        Console.WriteLine($"The number of employees by static variable is {EmployeeInfoSTL.numEmployees}");
        Console.WriteLine($"The number of employees by List size is {empl.Count}");
        Console.WriteLine();

        Console.WriteLine("Print information using a foreach loop");
        foreach (EmployeeInfoSTL info in empl)
        {
            EmployeeInfoSTL.Err_Status ret = info.PrintInfo();
            if (ret == EmployeeInfoSTL.Err_Status.Err_Failure)
            {
                Console.WriteLine($"Failed to get information for {info.GetName()}\n");
            }
        }
        Console.WriteLine();

        EmployeeInfoSTL empl4 = new EmployeeInfoSTL("Bill Durnham", "Product Support Specialist", 84000.00);
        empl[0] = empl4; // Replaces Sarah Smith
        empl.RemoveAt(empl.Count - 1); // Removes Jessica Lee

        for (int i = 0; i < empl.Count; ++i)
        {
            EmployeeInfoSTL.Err_Status ret = empl[i].PrintInfo();
            if (ret == EmployeeInfoSTL.Err_Status.Err_Failure)
            {
                Console.WriteLine($"Failed to get information for {empl[i].GetName()}\n");
            }
        }
        Console.WriteLine();

        Console.WriteLine($"The number of employees by static variable is {EmployeeInfoSTL.numEmployees}");
        Console.WriteLine($"The number of employees by List size is {empl.Count}");
        Console.WriteLine();
    }
}
